#if ! defined(__MSTKRUSKAL_H)
#define __MSTKRUSKAL_H

/* ----------------------------------------------------------------- */
#include "cb.h"

typedef struct {
  float weight; // the weight of edge (index1, index2)
  int    index1; // index of Book
  int    index2;
} Pair;

typedef struct {
  Pair* Pairs;
  int    PairSize;
} PairInfo;

PairInfo  * OrganizePairsFromTrainingSet(TRAININGSET *TS);
int       * MST_Kruskal(int bookSize, PairInfo *PInfo);
int       * MST_KruskalFromTrainingSetReturnPair(TRAININGSET *TS);
int       * MST_KruskalFromVectorSetReturnPair(float ** Vectors, int vectorSize, int bookSize);
int       * MST_KruskalFromPairsReturnPair(TRAININGSET *TS, PairInfo *PInfo);

Graph     * MST_KruskalFromTainingSet(TRAININGSET *TS);
Graph     * MST_KruskalFromPairs(TRAININGSET *TS, PairInfo *PInfo);
Graph     * MSTGraph(TRAININGSET *TS, int * PairResult);



/* ----------------------------------------------------------------- */

#endif /* __MSTKRUSKAL_H */
