/*-------------------------------------------------------------------*/
/* kMSTKruskal.c   ZHONG Caiming                                     */
/*                 09-08-2009                                        */
/*                                                                   */
/*-------------------------------------------------------------------*/

#define ProgName       "kMSTKruskal"
#define VersionNumber  "Version 0.1"
#define LastUpdated    "26.08.2009"

/*-------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>

#include "kMSTKruskal.h"
#include "MSTKruskal.h"
#include "memctrl.h"

/*-------------------------------------------------------------------*/

void RemovePriorMST(PairInfo * PInfo, int * PairResult, TRAININGSET *TS){
  int   i;
  Pair  *PS = PInfo->Pairs;
  int   bookSize = BookSize(TS);
  int   PairResultSize = PairResult[(bookSize - 1) * 3];

  for (i = 0; i < PairResultSize; i ++)
    PS[PairResult[i * 3 + 2]].weight = MAXLLONG;

}

/*-------------------------------------------------------------------*/

Graph * kMSTKruskal(TRAININGSET *TS, int k){
  int i;
  PairInfo * PInfo;
  Graph ** g = (Graph **)allocate(sizeof(Graph *) * k);
  Graph * graph = NULL;

  int * PairResult;
  PInfo = OrganizePairsFromTrainingSet(TS);

  for (i = 0; i < k; i ++){
    if (i > 0){
      RemovePriorMST(PInfo, PairResult, TS);
      deallocate(PairResult);
    }
    
    PairResult = MST_Kruskal(TS, PInfo);  
    g[i] =  MSTGraph(TS, PairResult);
  }
  deallocate(PInfo->Pairs);
  deallocate(PInfo);

  // combine k graphs
  for (i = 1; i < k; i ++){
    //To be after new GRAPH format version is available
  }
  return graph;
}
