#if ! defined(__PNNGRAPH_H)
#define __PNNGRAPH_H

#include "owntypes.h"
#include "cb.h"
#include "heap.h"


/*----------------------- Type definitions --------------------------*/


typedef struct { llong  VectorDist;
                 int    Vector;
                 YESNO  Recalculate;
               } NEARESTTYPE;

typedef struct { int*    codesum;    /* Element sums of the code vectors */
                 int*    codeorder;  /* Order for code vectors */
                 int*    mynumber;   /*MPSindex of trainingvector*/
               } DATA;

typedef struct V    {   struct V *link ;
                        int     data ;
                    } VERTEX ;

typedef struct { NEARESTTYPE** NN;
                 VERTEX** head;
               } KNNDATA;

typedef struct { llong dist;
                 int   from, to;
                 int   heapindex;
               } DISTELEM;

typedef struct { DISTELEM** DM;
                 HEAP       H;
               } KDATA;

/*--------------------------------------------------------------------*/

void PNNGraph(TRAININGSET*  TS,
             CODEBOOK*      CB,
             PARTITIONING*  P,
             int            K,
             int            FinalSize,
             int            Heap,
             int            GCMethod,
             int            QuietLevel,
             long           watch,
             int		    Pds,
             int			Mps,
             int            Mlf,
             int            Lazy,
             int            Cf);

/*--------------------------------------------------------------------*/

Graph* PNNGraph2(TRAININGSET* TS,
             CODEBOOK*      CB,
             PARTITIONING*  P,
             int            K,
             int            FinalSize,
             int            Heap,
             int            GCMethod,
             int            QuietLevel,
             long           watch,
             int		    Pds,
             int			Mps,
             int            Mlf,
             int            Lazy,
             int            Cf);

/*--------------------------------------------------------------------*/
void CalculateAllDistances(CODEBOOK* CB,
                           DATA*     D,
                           NEARESTTYPE NN[],
                           int Quiet,
                           long watch,
                           int Pds,
                           int Mps);
void FindMergedPair(CODEBOOK* CB, DATA* D, NEARESTTYPE NN[], int* a, int* b,
                           int Pds, int Mps);
void MergeVectors(TRAININGSET*   TS,
                  CODEBOOK*      CB,
                  PARTITIONING*  P,
                  NEARESTTYPE    NN[],
                  int            a,
                  int            b);
void RecalculateDistances(CODEBOOK* CB, NEARESTTYPE NN[], int aex,
								 int Quiet, int Pds, int Lazy);
void RemoveEmptyPartitions(TRAININGSET*  TS,
                           CODEBOOK*     CB,
                           PARTITIONING* P,
                           int           FinalSize);
int CmpDistKurita(void* a, void* b, void* info);

#endif /* __PNNGRAPH_H */
